﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.3
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim Awake As PhoneWakeState
	Dim FTP1 As FTP
	Dim FTPTimer As Timer
	Dim InternetConnected As Boolean, ph As PhoneEvents
	Dim DownloadBusy, UploadBusy As Boolean
	Type FTPEntry2(Name As String, Timestamp As Long, Size As Long)
	Dim FTPfiles() As FTPEntry2, PrevFiles() As FTPEntry2
	Dim ftp_DownloadFolder As String = "screenshots"
	Dim ftp_UploadFolder As String = "screenshots"
	Dim ftp_server As String = "ftp.server.ru"
	Dim ftp_port As Int = 21
	Dim ftp_login As String = "user"
	Dim ftp_pass As String = "password"
End Sub

Sub Service_Create
	ph.Initialize("ph")
	FTPTimer.Initialize("FTPTimer", 1000)
End Sub

Sub Service_Start (StartingIntent As Intent)
	Awake.PartialLock
	ph.Initialize("ph")
	Init_Ftp
End Sub

Sub Service_Destroy
	Awake.ReleasePartialLock
	FTPTimer.Enabled = False
	FTP1.CloseNow
	DownloadBusy = False
	UploadBusy = False
End Sub

Sub ph_ConnectivityChanged (NetworkType As String, State As String, Intent As Intent)
	If State = "CONNECTED" Then
		InternetConnected = True
	Else	'NO INTERNET
		InternetConnected = False
		Close_FTP
	End If

End Sub

'FTP
Sub Init_Ftp
	ph.Initialize("ph")
	Wait For ph_ConnectivityChanged (NetworkType As String, State As String, Intent As Intent)
	If State = "CONNECTED" Then
		Log("ph_ConnectivityChanged: CONNECTED" & "," & NetworkType)
		InternetConnected = True
	Else	'NO INTERNET
		Log("ph_ConnectivityChanged: DISCONNECTED")
		InternetConnected = False
		Close_FTP
		Return
	End If
	
	Try
		If FTP1.IsInitialized Then FTP1.CloseNow
		DownloadBusy = False
		UploadBusy = False
		Log("Init_Ftp...")
	
		FTP1.Initialize("FTP1",ftp_server, ftp_port, ftp_login, ftp_pass)
		FTP1.PassiveMode = True
		Log("FTP inited OK")
		'FTPTimer.Enabled = True
		'Get_FTPList(ftp_UploadFolder)
		CallSubDelayed(Me, "FTP_inited")
	Catch
		Log("Init_Ftp ERROR: " & LastException.Message)
	End Try

End Sub

Sub Get_FTPList (fol As String)
	If FTP1.IsInitialized = False Then
		Init_Ftp
		Wait for FTP_inited
	End If

	If DownloadBusy Or UploadBusy Then Return	'wait
	FTP1.PassiveMode = True
	FTP1.List(fol)
End Sub

Sub FTPTimer_Tick
	If FTP1.IsInitialized = False Then
		Return
	End If
	FTPTimer.Enabled = False
	CallSub2(Me, "Get_FTPList", ftp_DownloadFolder)
End Sub

Sub FTP1_ListCompleted (ServerPath As String, Success As Boolean, Folders() As FTPEntry, Files() As FTPEntry)
	Log("ListCompleted: " & ServerPath & ", ListingSuccess=" & Success)
	ProgressDialogHide
	If Success = False Then
		Log("FTP listing error: " & LastException.Message)
		Close_FTP
		Return
	Else
		Log("FTP logged in OK: " & ServerPath)
		For i = 0 To Files.Length - 1
			Log("File size =" & Files(i).Size)
		Next
		Close_FTP
	End If

End Sub

Sub Upload_file(fol As String, fn As String)
	If File.Exists(fol, fn) = False Then
		Log("FTP upload: no file")
		Return
	End If
	If File.Size(fol, fn) = 0 Then
		Log("FTP upload: empty file")
		Return
	End If
	
	Log("file size = " & File.Size(fol, fn))
	Init_Ftp
	Wait for FTP_inited
	Get_FTPList(ftp_UploadFolder)
	Wait for FTP1_ListCompleted (ServerPath As String, Success As Boolean, Folders() As FTPEntry, Files() As FTPEntry)
	Log("FTP1_ListCompleted = " & Success & " for " & ServerPath)
	If Success Then
		Log("FTP uploading..."  & fn)
		FTP1.UploadFile(fol, fn, False, ftp_UploadFolder & "/" & fn)
	Else
		Close_FTP
	End If
End Sub

Sub Close_FTP
	FTP1.CloseNow
	DownloadBusy = False
	UploadBusy = False
	StopService(Me)
End Sub

'Sub FTP1_UploadProgress (ServerPath As String, TotalUploaded As Long, Total As Long)
'	Dim s As String
'	s = "Uploaded " & Round(TotalUploaded / 1000000) & "MB"
'	If Total > 0 Then s = s & " out of " & Round(Total / 1000000) & "MB"
'	Log(s)
'End Sub

Sub FTP1_UploadCompleted (ServerPath As String, Success As Boolean)
	UploadBusy = False
	If Success = False Then
		Log("Upload FAILED: " & LastException.Message)
		Close_FTP
		Return
	Else
		'Close_FTP
		Get_FTPList(ftp_UploadFolder)
		Log("FTP uploaded OK")
	End If
End Sub


'Sub FTP1_CommandCompleted (Command As String, Success As Boolean, ReplyCode As Int, ReplyString As String)
'#if debug
'	Log("FTP1command: " & Command & ",result = " & Success & ",ReplyCode: " & ReplyCode & ",string= " & ReplyString)
'#end if
'
'	If Success Then
'		Log(("FTP1_CommandCompleted OK: " & Command)
'	Else
'		Log(("FTP1_CommandCompleted: " & Command & " with ERROR: " & ReplyCode & ", " & ReplyString)
'		Close_FTP
'	End If
'End Sub